Index: /mods/wpsg_mod_downloadplus.class.php
===================================================================
--- /mods/wpsg_mod_downloadplus.class.php	(revision 7823)
+++ /mods/wpsg_mod_downloadplus.class.php	(revision 7824)
@@ -414,194 +544,178 @@
 				");
 
-            if ($db_indiv['id'] > 0)
-            {
-
-                $new_name = $this->getNewName($_REQUEST['file'], $_REQUEST['edit_id'], $_REQUEST['product_key'], $db_indiv['downloadnr'], $_REQUEST['product_index']);
-
-                $this->db->UpdateQuery(WPSG_TBL_PDFINDIV, array(
-                    "scheduled" => "NOW()",
-                    "out_file" => wpsg_q($new_name)
-                ), "`id` = '".wpsg_q($db_indiv['id'])."'");
-
-            }
-            else
-            {
-
-                $download_nr = $this->getDownloadNr($_REQUEST['edit_id'], $_REQUEST['product_key'], $_REQUEST['product_index']);
-
-                $new_name = $this->getNewName($_REQUEST['file'], $_REQUEST['edit_id'], $_REQUEST['product_key'], $download_nr, $_REQUEST['product_index']);
-
-                $this->db->ImportQuery(WPSG_TBL_PDFINDIV, array(
-                    "o_id" => wpsg_q($_REQUEST['edit_id']),
-                    "p_key" => wpsg_q($_REQUEST['product_key']),
-                    'product_index' => wpsg_q($_REQUEST['product_index']),
-                    "downloadnr" => wpsg_q($download_nr),
-                    "file" => wpsg_q($_REQUEST['file']),
-                    "scheduled" => "NOW()",
-                    "out_file" => wpsg_q($new_name)
-                ));
-
-            }
-
-            $this->arMessage[] = __('Datei wurde geplant.', 'wpsg');
-
-            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
-
-        }
-        else if ($_REQUEST['cmd'] == 'reindiv')
-        {
-
-            $this->indivOrder($_REQUEST['edit_id']);
-
-            $this->arMessage[] = __('Bestellung wurde geplant.', 'wpsg');
-
-            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
-
-        }
-        else if ($_REQUEST['cmd'] == 'reset')
-        {
-
-            $this->db->UpdateQuery(WPSG_TBL_PDFINDIV, array("counter" => "0"), "`o_id` = '".wpsg_q($_REQUEST['edit_id'])."'");
-
-            $this->arMessage[] = __('DownloadzÃ€hler wurden zurÃŒckgesetzt.', 'wpsg');
-
-            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
-
-        }
-        else if ($_REQUEST['cmd'] == 'send_files')
-        {
-
-            $this->sendFiles($_REQUEST['edit_id']);
-
-            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
-
-        }
-        else if ($_REQUEST['cmd'] == 'cancelschedule_file')
-        {
-
-            $this->db->Query("
-					DELETE FROM
-						`".WPSG_TBL_PDFINDIV."`
-					WHERE
-						`file` = '".wpsg_q($_REQUEST['file'])."' AND
-						`o_id` = '".wpsg_q($_REQUEST['edit_id'])."' AND
-						`p_key` = '".wpsg_q($_REQUEST['product_key'])."'
-				");
-
-            $this->arMessage[] = __('Planung wurde storniert.', 'wpsg');
-
-            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
-
-        }
-        else if ($_REQUEST['cmd'] == 'download_indivfile')
-        {
-
-            wpsg_ob_end_clean();
-
-            header('Content-Type: application/pdf');
-            header('Content-Disposition: inline; filename="'.rawurldecode(basename($_REQUEST['file'])).'"');
-            header('Cache-Control: private, max-age=0, must-revalidate');
-            header('Pragma: public');
-
-            die(file_get_contents($this->getPDFIndivPath($_REQUEST['edit_id']).'/'.rawurldecode($_REQUEST['file'])));
-
-        }
-
-    } // public function order_ajax()
-
-    public function order_view($order_id, &$arSidebarArray)
-    {
-
-        $bPDFProdukt = false;
-        $arFiles = array();
-
-        // Die arFiles brauch ich um zu bestimmen ob Produkte gekauft wurden, die Downloads enthalten
-        foreach ($this->shop->view['basket']['produkte'] as $k => $v)
-        {
-
-            $this->shop->view['arProducts'][$k] = $v;
-
-            if ($this->isPDFProdukt($v['id']))
-            {
-
-                $bPDFProdukt = true;
-
-                $product_id = $this->shop->getProduktID($v['id']);
-
-                // Hier darf das wpsg_array_merge nicht verwendet werden, da der Index nicht ÃŒberschrieben werden darf
-                //$arFiles = array_merge($arFiles, $this->getFiles($v['id']));
-                $arFiles_product = $this->getfiles($v['id']);
-
-                foreach ($arFiles_product as $file_product)
-                {
-
-                    $arFiles[] = array($product_id, $file_product);
+	            if ($db_indiv['id'] > 0) {
+
+	                $new_name = $this->getNewName($_REQUEST['file'], $_REQUEST['edit_id'], $_REQUEST['product_key'], $db_indiv['downloadnr'], $_REQUEST['product_index']);
+
+	                $this->db->UpdateQuery(WPSG_TBL_PDFINDIV, array(
+	                    "scheduled" => "NOW()",
+	                    "out_file" => wpsg_q($new_name)
+	                ), "`id` = '".wpsg_q($db_indiv['id'])."'");
+
+	            } else {
+
+	                $download_nr = $this->getDownloadNr($_REQUEST['edit_id'], $_REQUEST['product_key'], $_REQUEST['product_index']);
+
+	                $new_name = $this->getNewName($_REQUEST['file'], $_REQUEST['edit_id'], $_REQUEST['product_key'], $download_nr, $_REQUEST['product_index']);
+
+	                $oProduct = wpsg_product::getInstance($_REQUEST['product_key']);
+
+	                $this->db->ImportQuery(WPSG_TBL_PDFINDIV, array(
+	                    "o_id" => wpsg_q($_REQUEST['edit_id']),
+	                    "p_key" => wpsg_q($_REQUEST['product_key']),
+	                    'product_index' => wpsg_q($_REQUEST['product_index']),
+	                    "downloadnr" => wpsg_q($download_nr),
+	                    "file" => wpsg_q($_REQUEST['file']),
+	                    "scheduled" => "NOW()",
+	                    "out_file" => wpsg_q($new_name),
+		                'mode' => $oProduct->getMeta('mod_downloadplus_mode'),
+		                'template' => $this->getTemplateIdFromProduct($_REQUEST['product_key'])
+	                ));
+
+	            }
+
+	            $this->arMessage[] = __('Datei wurde geplant.', 'wpsg');
+
+	            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
+
+	        } else if ($_REQUEST['cmd'] == 'reindiv') {
+
+	            $this->indivOrder($_REQUEST['edit_id']);
+
+	            $this->arMessage[] = __('Bestellung wurde geplant.', 'wpsg');
+
+	            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
+
+	        }
+	        else if ($_REQUEST['cmd'] == 'reset')
+	        {
+
+	            $this->db->UpdateQuery(WPSG_TBL_PDFINDIV, array("counter" => "0"), "`o_id` = '".wpsg_q($_REQUEST['edit_id'])."'");
+
+	            $this->arMessage[] = __('DownloadzÃ€hler wurden zurÃŒckgesetzt.', 'wpsg');
+
+	            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
+
+	        }
+	        else if ($_REQUEST['cmd'] == 'send_files')
+	        {
+
+	            $this->sendFiles($_REQUEST['edit_id']);
+
+	            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
+
+	        }
+	        else if ($_REQUEST['cmd'] == 'cancelschedule_file')
+	        {
+
+	            $this->db->Query("
+						DELETE FROM
+							`".WPSG_TBL_PDFINDIV."`
+						WHERE
+							`file` = '".wpsg_q($_REQUEST['file'])."' AND
+							`o_id` = '".wpsg_q($_REQUEST['edit_id'])."' AND
+							`p_key` = '".wpsg_q($_REQUEST['product_key'])."'
+					");
+
+	            $this->arMessage[] = __('Planung wurde storniert.', 'wpsg');
+
+	            die($this->order_view_sidebar_renderList($_REQUEST['edit_id']));
+
+	        }
+	        else if ($_REQUEST['cmd'] == 'download_indivfile') {
+
+	            $order_id = intval($_REQUEST['edit_id']);
+	            $product_key = $_REQUEST['product_key'];
+	            $product_id = intval($this->shop->getProduktID($product_key));
+
+	            check_admin_referer('wpsg-dp-download-'.$order_id.'-'.$product_key);
+
+	            wpsg_ob_end_clean();
+
+	            header('Content-Type: application/pdf');
+	            header('Content-Disposition: inline; filename="'.rawurldecode(basename($_REQUEST['file'])).'"');
+	            header('Cache-Control: private, max-age=0, must-revalidate');
+	            header('Pragma: public');
+
+	            if (isset($_REQUEST['clear'])) die(file_get_contents($this->getPDFIndivPath($order_id).'/clear_'.rawurldecode($_REQUEST['file'])));
+	            else die(file_get_contents($this->getPDFIndivPath($order_id).'/'.rawurldecode($_REQUEST['file'])));
+
+	        }
+
+	    } // public function order_ajax()
+
+	    public function order_view($order_id, &$arSidebarArray) {
+
+	        $bPDFProdukt = false;
+	        $arFiles = array();
+
+	        // Die arFiles brauch ich um zu bestimmen ob Produkte gekauft wurden, die Downloads enthalten
+	        foreach ($this->shop->view['basket']['produkte'] as $k => $v) {
+
+	            $this->shop->view['arProducts'][$k] = $v;
+
+	            if ($this->isPDFProdukt($v['id'])) {
+
+	                $bPDFProdukt = true;
+
+	                $product_id = $this->shop->getProduktID($v['id']);
+
+	                // Hier darf das wpsg_array_merge nicht verwendet werden, da der Index nicht ÃŒberschrieben werden darf
+	                //$arFiles = array_merge($arFiles, $this->getFiles($v['id']));
+	                $arFiles_product = $this->getfiles($v['id']);
+
+	                foreach ($arFiles_product as $file_product) {
+
+	                    $arFiles[] = array($product_id, $file_product);
+
+	                }
+
+	            }
+
+	        }
+
+	        if ($bPDFProdukt && sizeof($arFiles) > 0) {
+
+	            $this->shop->view['order_id'] = $order_id;
+
+	            $arSidebarArray[$this->id] = array(
+	                'title' => $this->name,
+	                'content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/order_view_sidebar.phtml', false)
+	            );
+
+	        }
+
+	    } // public function order_view($order_id, &$arSidebarArray)
+
+	    public function order_view_sidebar_renderList($order_id) {
+
+	        $bPDFProdukt = false;
+	        $arFiles = array();
+
+	        $oOrder = wpsg_order::getInstance($order_id);
+
+	        foreach ($oOrder->getOrderProducts() as $oOrderProduct) {
+
+	        	$product_key = $oOrderProduct->getProductKey();
+	        	$product_files = $this->getFiles($product_key);
+
+	        	foreach ($product_files as $file) {
+
+	        		$bPDFProdukt = true;
+                    $arFiles[] = array($product_key, $file, $oOrderProduct->getProductIndex());
 
                 }
 
-            }
-
-        }
-
-        if ($bPDFProdukt && sizeof($arFiles) > 0)
-        {
-
-            $this->shop->view['order_id'] = $order_id;
-
-            $arSidebarArray[$this->id] = array(
-                'title' => $this->name,
-                'content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/order_view_sidebar.phtml', false)
-            );
-
-        }
-
-    } // public function order_view($order_id, &$arSidebarArray)
-
-    public function order_view_sidebar_renderList($order_id) {
-
-        $bPDFProdukt = false;
-        $arFiles = array();
-
-        $arBasket = $this->shop->cache->loadBasketArray($order_id);
-
-        foreach ($arBasket['produkte'] as $k => $v)
-        {
-
-            if ($this->isPDFProdukt($v['id']))
-            {
-
-                $bPDFProdukt = true;
-
-                if (wpsg_isSizedString($v['mod_vp_varkey'])) $product_key = $v['mod_vp_varkey']; else $product_key = $v['productkey'];
-
-                //$product_id = $this->shop->getProduktID($v['id']);
-
-                // Hier darf das wpsg_array_merge nicht verwendet werden, da der Index nicht ÃŒberschrieben werden darf 
-                //$arFiles = array_merge($arFiles, $this->getFiles($v['id']));
-
-                $product_files = $this->getFiles($v['id']);
-
-                foreach ($product_files as $file)
-                {
-
-                    $arFiles[] = array($product_key, $file, $v['product_index']);
-
-                }
-
-            }
-
-        }
-
-        $arIndivIDs = array();
-
-        if ($bPDFProdukt && wpsg_isSizedArray($arFiles))
-        {
-
-            $arFiles = wpsg_array_unique($arFiles);
-
-            foreach ($arFiles as $k => $v)
-            {
-
-                $db_indiv = $this->db->fetchRow("
+	        }
+
+	        $arIndivIDs = array();
+
+	        if ($bPDFProdukt && wpsg_isSizedArray($arFiles)) {
+
+	            $arFiles = wpsg_array_unique($arFiles);
+
+	            foreach ($arFiles as $k => $v) {
+
+	                $db_indiv = $this->db->fetchRow("
 						SELECT 
 							* 
